package tools;

import java.math.BigDecimal;
import cartago.*;

public class Env extends Artifact {

    private Display display;

    void init() {
        this.defineObsProperty("numMsg",0);
        display = new Display();
        display.setVisible(true);
        System.out.println("Env ready.");
    }

    @OPERATION void printMsg(String msg){
        String agentName = this.getCurrentOpAgentId().getAgentName();
        display.addText("Message from "+agentName+": "+msg);
      ObsProperty prop = this.getObsProperty("numMsg");
        prop.updateValue(prop.intValue()+1);
        display.updateNumMsgField(prop.intValue());
    }

        @OPERATION void computePi(int numDigits, OpFeedbackParam<String> res){
            BigDecimal digits = CalcLib.computePiDigits(numDigits);
            res.set(digits.toPlainString());
        }
        
}
